﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Net.Sockets;
using System.Threading;
using System.Net;
using System.IO;
using System.Text.RegularExpressions;

namespace Win
{
    public partial class Form1 : Form
    {
        public delegate void UpdateRichTextBoxCallback(string text);
        public   Socket  socketSend;
        IPAddress IPAdd;
        int iPort = 0;

        Thread th;
        Thread thListen;

        string sort = "";

        private int MoveY = 0;
        private int MoveX = 0;
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            //取默认数据
            txtIP.Text = "127.0.0.1";
            txtport.Text = "3001";
            int iPort = 0;
            string sip = IniCls.IniReadValue("settingScene", "serverip");
            string sport = IniCls.IniReadValue("settingScene", "serverport");
            if (int.TryParse(sport, out iPort))
            {
                txtport.Text = sport;
            }
            if (IPAddress.TryParse(sip, out IPAdd))
            {
                txtIP.Text = sip;
            }
        }
        private void Form1_FormClosed(object sender, FormClosedEventArgs e)
        {            //保存数据
            int iPort = 0;
            IPAddress IPAdd;
            string sip = txtIP.Text.Trim();
            string sport = txtport.Text.Trim();

            if (int.TryParse(sport, out iPort))
            {
                IniCls.IniWriteValue("settingScene", "serverport", sport);
            }
            if (IPAddress.TryParse(sip, out IPAdd))
            {
                IniCls.IniWriteValue("settingScene", "serverip", sip);
            }

            Environment.Exit(0);
        }

        private bool CheckIPPort()
        {
            string sip = txtIP.Text.Trim();
            string sport = txtport.Text.Trim();
            if (int.TryParse(sport, out iPort) == false || IPAddress.TryParse(sip, out IPAdd) == false)
            {
                MessageBox.Show("端口号、连接数量不能为空！");
                return false;
            }
            else
            {
                return true;
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            try
            {
                if (brnConnect.Text == "连接")
                {
                    if (CheckIPPort() == false) return;

                     socketSend = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);
                    socketSend.Connect(IPAdd, iPort);	//建立连接.
                    AppendToRichTextBoxControl("连接成功");
                    AppendToRichTextBoxControl("服务器" + socketSend.RemoteEndPoint.ToString());
                    AppendToRichTextBoxControl("客户端" + socketSend.LocalEndPoint.ToString());

                     th = new Thread(ReceiveMsg);	//写法类似Runnable.
                    th.Start();	//开启线程

                    //thListen = new Thread(ReceiveMsg);
                    brnConnect.Text = "断开";
                }
                else
                {
                    brnConnect.Text = "连接";
                    socketSend.Close();
                    th.Abort();
                    
                }

            }
            catch (Exception ex)
            {
                AppendToRichTextBoxControl("客户端错误" + ex.Message);
                brnConnect.Text = "连接";

            }
        }

	private void ReceiveMsg()
	 {
         while (true )
	    {
            if (socketSend.Connected == true)
            {
                try
                {
                    byte[] buffer = new byte[1024 * 1024];
                    int len = socketSend.Receive(buffer);   //获取长度
                    string s = "";
                    if (len == 0) break; 
                    //if (sort == "ASCII")
                    //{
                    //     s = Encoding.ASCII.GetString(buffer, 0, len);	//从buffer中获得字符串.
                    //}
                    //else
                    //{
                    //    s = Encoding.UTF8.GetString(buffer, 0, len);	//从buffer中获得字符串.
                    //}
                    s = s + "  ";
                    for (int i=0; i<len;i++)
                    {
                        s = s + buffer[i].ToString("X2");
                    }

                    //打印机在打印过程中出现错误 返回的是7B FF FF XX XX 7C 00 00 00 00 7D
                    //打印完成返回的是                   7B FF FE XX XX 7C 00 00 00 00 7D
                    // 7C  和  7D 之间是 故障信息
                    //7BFF FE00 047C C000 0000 7D
                      byte[] bb = new byte[4];  //

                        UInt32 retms = 0;
                        if (len >= 10)
                        {
                            if ((buffer[0] == 0x7B) && (buffer[1] == 0xFF))
                            {
                                if (((int)buffer[2] & 0xFF) > 0)
                                {
                                    s = s + " 正在打印中。 ";
                                }
                                if (((int)buffer[2] & 0xFE) > 0)
                                {
                                    s = s + " 打印完成。 ";
                                }
                                if (((int)buffer[2] & 0xFD) > 0)
                                {
                                    s = s + " 贴标完成。 ";
                                }

                                bb[0] = buffer[6];
                                bb[1] = buffer[7];
                                bb[2] = buffer[8];
                                bb[3] = buffer[9];
                                retms = BitConverter.ToUInt32(bb, 0);
                                
                                if ((retms & 0x01) > 0) { s = s + " 打印机暂停 "; }
                                if ((retms & 0x02) > 0) { s = s + " 打印头抬起 "; }
                                if ((retms & 0x04) > 0) { s = s + " 打印机缺纸 "; }
                                if ((retms & 0x08) > 0) { s = s + " 色带缺失 "; }
                                if ((retms & 0x10) > 0) { s = s + " 色带错误 "; }
                                if ((retms & 0x20) > 0) { s = s + " 黑标错误 "; }
                                if ((retms & 0x40) > 0) { s = s + " 打印头温度过高 "; }
                                if ((retms & 0x80) > 0) { s = s + " 打印头电压过低 "; }
                                if ((retms & 0x100) > 0) { s = s + " 打印数据异常"; }
                                if ((retms & 0x200) > 0) { s = s + " 贴标异常 "; }


                                //if (((int)buffer[2] & 0x01) > 0)
                                //{
                                //    bb[0] = buffer[6];
                                //    bb[1] = buffer[7];
                                //    bb[2] = buffer[8];
                                //    bb[3] = buffer[9];
                                //    retms = BitConverter.ToUInt32(bb, 0);
                                //    //s = "";
                                //    if ((retms & 0x80000) > 0) { s = s + " 正在打印 "; }
                                //    if ((retms & 0x01) > 0) { s = s + " 打印机暂停 "; }
                                //    if ((retms & 0x02) > 0) { s = s + " 打印头抬起 "; }
                                //    if ((retms & 0x04) > 0) { s = s + " 打印机缺纸 "; }
                                //    if ((retms & 0x08) > 0) { s = s + " 色带缺失 "; }
                                //    if ((retms & 0x10) > 0) { s = s + " 色带错误 "; }
                                //    if ((retms & 0x20) > 0) { s = s + " 黑标错误 "; }
                                //    if ((retms & 0x40) > 0) { s = s + " 打印头温度过高 "; }
                                //    if ((retms & 0x80) > 0) { s = s + " 打印头电压过低 "; }
                                //    if ((retms & 0x100) > 0) { s = s + " 指令错误 "; }
                                //    if ((retms & 0x200) > 0) { s = s + " 环境温度过高 "; }
                                //}
                                //else
                                //{
                                //    s = s + " 打印完成 ";
                                //}
                            }

                        }
                            //strrec = strrec+ s;

                    //将信息显示在textArea中.
                    
                    AppendToRichTextBoxControl("ReceiveMsg1" + s);

                }
                catch (Exception ex)
                {
                    AppendToRichTextBoxControl("ReceiveMsg2" + ex.Message);
                    break;
                }
            }
            else
            {
                socketSend.Connect(IPAdd, iPort);	//建立连接.
            }
      }

   }

    //更新文本数据 
    private void AppendToRichTextBoxControl(string msg)
    {
        if (InvokeRequired)
        {
            object[] pList = { msg };
            this.richTextBox1.BeginInvoke(new UpdateRichTextBoxCallback(AppendToRichTextBoxControl), pList);
        }
        else
        {
            if (richTextBox1.Text.Length > 1500)
            {
                this.richTextBox1.Clear();
            }
            this.richTextBox1.AppendText(msg + "\n");
            this.richTextBox1.ScrollToCaret();
        }

    }


    private void showMsg(string msg)
   {
       System.DateTime currentTime = new System.DateTime();//创建DateTime对象
       currentTime = System.DateTime.Now;//对象当前时间.
       richTextBox1.AppendText(currentTime.ToString() + "\r\n"); //发送时间
       richTextBox1.AppendText(msg + "\r\n");
       richTextBox1.AppendText("\r\n"); //换行,注目.
   }

        private void btnsend_Click(object sender, EventArgs e)
        {
            try
            {
                //if (socketSend.LingerState=)
                //发送消息
                //发送消息.
                //showMsg(txtMsg.Text);
                byte[] buffer = Encoding.UTF8.GetBytes(txtMsg1.Text);
                socketSend.Send(buffer);	//发送消息,以流的形式.
            }
            catch(Exception ex)
           {
               AppendToRichTextBoxControl("btnsend_Click" + ex.Message);
               
           }
           
        }

        private void btnsend_Click_1(object sender, EventArgs e)
        {
            if (socketSend.Connected == true)
            {
            
                string strout = "";
                int lableno = 1;
                string FileLabno = "\\ng.prn";


                // 如果位置不准可以 自动少量移动标签的坐标  下面是坐标移动的数据信息判断 
                try
                {
                    MoveX = int.Parse(txtX.Text.Trim());
                    if (MoveX > 50 || MoveX < -50)
                    {
                        MoveX = 0;
                    }
                }
                catch
                {
                    MoveX = 0;
                }

                try
                {
                    MoveY = int.Parse(txtY.Text.Trim());
                    if (MoveY > 50 || MoveY < -50)
                    {
                        MoveY = 0;
                    }
                }
                catch
                {
                    MoveY = 0;
                }

                // 判断用户选择的不同标签 ，选择不同的标签模板 
                if (Rb1.Checked == true) lableno = 1;
                if (Rb2.Checked == true) lableno = 2;
                if (Rb3.Checked == true) lableno = 3;
                if (Rb4.Checked == true) lableno = 4;
                if (Rb5.Checked == true) lableno = 5;
                if (Rb6.Checked == true) lableno = 6;
                if (Rb7.Checked == true) lableno = 7;
                if (Rb8.Checked == true) lableno = 8;

                switch(lableno)
                {
                    case 1:
                        FileLabno = txtMsg1.Text.Trim();
                        break;
                    case 2:
                        FileLabno = txtMsg2.Text.Trim();
                        break;
                    case 3:
                        FileLabno = txtMsg3.Text.Trim();
                        break;
                    case 4:
                        FileLabno = txtMsg4.Text.Trim();
                        break;
                    case 5:
                        FileLabno = txtMsg5.Text.Trim();
                        break;
                    case 6:
                        FileLabno = txtMsg6.Text.Trim();
                        break;
                    case 7:
                        FileLabno = txtMsg7.Text.Trim();
                        break;
                    case 8:
                        FileLabno = txtMsg8.Text.Trim();
                        break;
                    default:
                          FileLabno = txtMsg1.Text.Trim();
                        break;

                }

                //调用函数 打印 
               
                strout = ReplaceInFile(FileLabno, textBox1.Text, textBox2.Text, textBox3.Text,
                                     "", "", "", "", "", "", "", "", "", "", 
                                     "", "", "", txtNum.Text, Encoding.UTF8);
                if (strout == "")
                {
                    AppendToRichTextBoxControl("形成文件失败!");
                    return;
                }
                else
                { AppendToRichTextBoxControl(strout); }
                byte[] byteArray = System.Text.Encoding.UTF8.GetBytes(strout);
                //byte[] byteArray = System.Text.Encoding.ASCII .GetBytes(strout);
                socketSend.Send(byteArray);
                //socketSend.Send(strout);
            }
        }

        private void button1_Click_1(object sender, EventArgs e)
        {
            if (socketSend.Connected == true)
            {
                sort = "ASCII";
                string strout = "";
                //strout = ReplaceInFile(txtMsg1.Text, textBox1.Text, "CY12345678", "12", "3000", "500", "600",
                //    "VJCB3CX-2400000", "20", "81.1", "80", "BYGAB", "Spain", "", "", "2");
                if (strout == "")
                {
                    AppendToRichTextBoxControl("形成文件失败!");
                    return;
                }
                //byte[] byteArray = System.Text.Encoding.UTF8.GetBytes(strout);
                byte[] byteArray = System.Text.Encoding.ASCII.GetBytes(strout);
                socketSend.Send(byteArray);
                //socketSend.Send(strout);
            }
        }
        public string ReplaceInFile(string FileOld, string FileNew, string replaceText1, string replaceText2,
              string replaceText3, string replaceText4, string replaceText5, string replaceText6, string replaceText7,
              string replaceText8, string replaceText9, string replaceText10, string replaceText11, string replaceText12,
              string replaceText13, string replaceText14, string replaceText15, string strcount, Encoding encode)
        {
            //			int x1, y1;
            //			string x11,y11 ;
            if (File.Exists(FileNew) == true)
            {
                File.Delete(FileNew);
            }
            File.Copy(FileOld, FileNew);

            string strret = "";

            try
            {
                StreamReader reader = new StreamReader(FileNew, encode);  //Encoding.Default
                string content = reader.ReadToEnd();
                reader.Close();
                string[] str = new string[17];
                str[0] = replaceText1; str[1] = replaceText2; str[2] = replaceText3; str[3] = replaceText4;
                str[4] = replaceText5; str[5] = replaceText6; str[6] = replaceText7; str[7] = replaceText8;
                str[8] = replaceText9; str[9] = replaceText10; str[10] = replaceText11; str[11] = replaceText12;
                str[12] = replaceText13;

                str[13] = replaceText14;  //202007 add 
                str[14] = replaceText15;   //202007 add 
                str[15] = "";    //202007 需要拆分 规格  中的规格
                str[16] = "";    //202007 需要拆分 规格   中的长度

                int linstr = replaceText3.IndexOf("*");

                if (linstr > 0)
                {
                    str[15] = replaceText3.Substring(0, linstr);
                    str[16] = replaceText3.Substring(linstr + 1, replaceText3.Length - linstr - 1);
                }
                else
                {
                    str[16] = "";
                    str[15] = replaceText3;
                }

                string[] resultString = Regex.Split(content, "\r\n", RegexOptions.IgnoreCase);
                for (int ll = 0; ll < resultString.Length; ll++)
                {
                    if (resultString[ll].StartsWith("{PC") | resultString[ll].StartsWith("{XB") )
                    {
                        for (int ii = 1; ii <= 15; ii++)
                        {

                            for (int n = 1; n <= 17; n++)
                            {
                                resultString[ll] = resultString[ll].Replace("(" + n.ToString() + ")", str[n - 1]);
                            }

                            
                        }
                    }
                    if (resultString[ll].StartsWith("{XS;"))
                    {
                        string[] strline = Regex.Split(resultString[ll], ",", RegexOptions.IgnoreCase);
                        if (strline.Length > 2)
                        {
                            if (strcount.Length != 4)
                            {
                                strcount = "0000" + strcount;
                                strcount = strcount.Substring(strcount.Length - 4, 4);
                            }
                            resultString[ll] = strline[0] + "," + strcount + "," + strline[2];
                        }
                    }
                }
                ////处理条码信息     条码是参数信息 不自己组合了，不在使用下面程序 
                //for (int ll = 0; ll < resultString.Length; ll++)
                //{
                //    if (resultString[ll].StartsWith("{XB"))
                //    {
                //        string[] strline = Regex.Split(resultString[ll], ",", RegexOptions.IgnoreCase);
                //        if (strline.Length > 4)
                //        {
                //            if (strline[2] == "T") //QR码
                //            {
                //                for (int n = 1; n <= 17; n++)
                //                {
                //                    resultString[ll] = resultString[ll].Replace("(" + n.ToString() + ")", str[n - 1]);
                //                }
                //            }
                //            if (strline[2] == "A") //一维数据
                //            {
                //                int n = resultString[ll].IndexOf("=");
                //                if (n > 0)
                //                {
                //                    string str128 = resultString[ll].Substring(n + 1, resultString[ll].Length - n - 3);
                //                    for (int m = 1; m <= 15; m++)
                //                    {
                //                        //str128 = Regex.Replace(str128, "(" + m.ToString() + ")", str[m - 1]);
                //                        str128 = str128.Replace("(" + m.ToString() + ")", str[m - 1]);
                //                        //int l = str128.IndexOf("(" + (m).ToString() + ")");
                //                        //if (l > 0)
                //                        //{
                //                        //    str128 = resultString[ll].Substring(0, l + 1) + str[ii - 1] + "|}";
                //                        //}
                //                    }
                //                    str128 = change128(str128);

                //                    resultString[ll] = resultString[ll].Substring(0, n + 1) + str128 + "|}";

                //                }
                //            }
                //        }
                //    }
                //if (resultString[ll].StartsWith("{XS;"))
                //{
                //    string[] strline = Regex.Split(resultString[ll], ",", RegexOptions.IgnoreCase);
                //    if (strline.Length > 2)
                //    {
                //        if (strcount.Length != 4)
                //        {
                //            strcount = "0000" + strcount;
                //            strcount = str[11].Substring(strcount.Length - 4, 4);
                //        }
                //        resultString[ll] = strline[0] + "," + strcount + "," + strline[2];
                //    }
                //}
            //}


                //坐标处理
                int Lt = 0;

                int x1, y1;
                string x11, y11;

                for (int Lin = 0; Lin < resultString.Length; Lin++)
                {
                    //if(strline.Substring()
                    if (resultString[Lin].StartsWith("{SG") || resultString[Lin].StartsWith("{P") || resultString[Lin].StartsWith("{XB")
                          || resultString[Lin].StartsWith("{LC"))
                    {
                        string[] strOneLine = (resultString[Lin]).Split(',');

                        int mytemp0 = strOneLine[0].IndexOf(";") + 1;
                        string stPersition = strOneLine[0].Substring(mytemp0, strOneLine[0].Length - mytemp0);
                        int result = int.Parse(stPersition);
                        x1 = result + MoveX;
                        if (x1 < 0)
                        { x1 = 0; }
                        x11 = string.Format("{0:D4}", x1);
                        int mytemp = strOneLine[0].IndexOf(";") + 1;
                        strOneLine[0] = strOneLine[0].Substring(0, mytemp) + x11;


                        Lt = int.Parse(strOneLine[1]);  //y坐标
                        y1 = Lt + MoveY;
                        if (y1 < 0)
                        { y1 = 0; }
                        y11 = string.Format("{0:D4}", y1);
                        strOneLine[1] = y11;


                        if (resultString[Lin].StartsWith("{LC"))
                        {
                            Lt = int.Parse(strOneLine[2]);
                            x1 = Lt + MoveX;
                            if (x1 < 0)
                            { x1 = 0; }
                            x11 = string.Format("{0:D4}", x1);
                            strOneLine[2] = x11;

                            Lt = int.Parse(strOneLine[3]);   //yz坐标
                            y1 = Lt + MoveY;
                            if (y1 < 0)
                            { y1 = 0; }
                            y11 = string.Format("{0:D4}", y1);
                            strOneLine[3] = y11;
                        }
                        resultString[Lin] = "";
                        for (int LL = 0; LL < strOneLine.Length; LL++)
                        {
                            if (LL != strOneLine.Length - 1)
                            { resultString[Lin] = resultString[Lin] + strOneLine[LL] + ","; }
                            else
                            { resultString[Lin] = resultString[Lin] + strOneLine[LL]; }
                        }
                    }
                }

                StreamWriter writer = new StreamWriter(FileNew, false, encode);   // 
                for (int LL = 0; LL < resultString.Length; LL++)
                {
                    strret = strret + resultString[LL] + "\r\n";
                    writer.WriteLine(resultString[LL]);
                }
                writer.Close();

            }
            catch (System.Exception ee)
            {
                MessageBox.Show("打印失败！失败原因：" + ee.ToString());
            }

            return strret;
        }


        private void button2_Click(object sender, EventArgs e)
        {
            UInt32 retms = 0;

            //打印机在打印过程中出现错误 返回的是7B FF FF XX XX 7C 00 00 00 00 7D
            //打印完成返回的是                   7B FF FE XX XX 7C 00 00 00 00 7D
            // 7C  和  7D 之间是 故障信息
            //7BFF FE00 047C C000 0000 7D
            byte[] buffer = new byte[11];  //

            buffer[0] = 0x7B; buffer[1] = 0xFF; buffer[2] = 0xFE; buffer[3] = 0x00;
            buffer[4] = 0x00; buffer[5] = 0x7C; buffer[6] = 0x01; buffer[7] = 0x01;
            buffer[8] = 0x01; buffer[9] = 0x01; buffer[10] = 0x7D;

            byte[] bb = new byte[4];  //

            int len = 10;

            string s = "";
            if (len >= 10)
            {
                if ((buffer[0] == 0x7B) && (buffer[1] == 0xFF))
                {
                    //if (((int)buffer[2] & 0x01) > 0)
                    if  (buffer[2] == 0xFF)
                    {
                        bb[0] = buffer[6];
                        bb[1] = buffer[7];
                        bb[2] = buffer[8];
                        bb[3] = buffer[9];
                        retms = BitConverter.ToUInt32(bb, 0);
                        //s = "";
                        if ((retms & 0x80000) > 0) { s = s + "正在打印 "; }
                        if ((retms & 0x01) > 0) { s = s + "打印机暂停 "; }
                        if ((retms & 0x02) > 0) { s = s + "打印头抬起 "; }
                        if ((retms & 0x04) > 0) { s = s + "打印机缺纸 "; }
                        if ((retms & 0x08) > 0) { s = s + "色带缺失 "; }
                        if ((retms & 0x10) > 0) { s = s + "色带错误 "; }
                        if ((retms & 0x20) > 0) { s = s + "黑标错误 "; }
                        if ((retms & 0x40) > 0) { s = s + "打印头温度过高 "; }
                        if ((retms & 0x80) > 0) { s = s + "打印头电压过低 "; }
                        if ((retms & 0x100) > 0) { s = s + "指令错误 "; }
                        if ((retms & 0x200) > 0) { s = s + "环境温度过高 "; }
                    }
                    else
                    {
                        s = s + " 打印完成 ";
                    }
                }

            }

        }
    }
}


